org.apache.commons.math.linear

## Class AbstractFieldMatrix<T extends FieldElement<T>>

- java.lang.Object
- - org.apache.commons.math.linear.AbstractFieldMatrix<T>

- Type Parameters:
    `T` - the type of the field elements
  All Implemented Interfaces:
    AnyMatrix, FieldMatrix<T>
  Direct Known Subclasses:
    Array2DRowFieldMatrix, BlockFieldMatrix, SparseFieldMatrix

      public abstract class AbstractFieldMatrix<T extends FieldElement<T>>
      extends Object
      implements FieldMatrix<T>

  Basic implementation of `FieldMatrix` methods regardless of the underlying storage.

  All the methods implemented here use `getEntry(int, int)` to access matrix elements. Derived class can provide faster implementations.

  Since:
    2.0
  Version:
    $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 févr. 2011) $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private Field<T>` | `field` Field to which the elements belong.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractFieldMatrix()` Constructor for use with Serializable
    `protected` | `AbstractFieldMatrix(Field<T> field)` Creates a matrix with no data
    `protected` | `AbstractFieldMatrix(Field<T> field, int rowDimension, int columnDimension)` Create a new FieldMatrix with the supplied row and column dimensions.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FieldMatrix<T>` | `add(FieldMatrix<T> m)` Compute the sum of this and m.
    `abstract void` | `addToEntry(int row, int column, T increment)` Change an entry in the specified row and column.
    `protected static <T extends FieldElement<T>> T[]` | `buildArray(Field<T> field, int length)` Build an array of elements.
    `protected static <T extends FieldElement<T>> T[][]` | `buildArray(Field<T> field, int rows, int columns)` Build an array of elements.
    `protected void` | `checkAdditionCompatible(FieldMatrix<T> m)` Check if a matrix is addition compatible with the instance
    `protected void` | `checkColumnIndex(int column)` Check if a column index is valid.
    `protected void` | `checkMultiplicationCompatible(FieldMatrix<T> m)` Check if a matrix is multiplication compatible with the instance
    `protected void` | `checkRowIndex(int row)` Check if a row index is valid.
    `protected void` | `checkSubMatrixIndex(int[] selectedRows, int[] selectedColumns)` Check if submatrix ranges indices are valid.
    `protected void` | `checkSubMatrixIndex(int startRow, int endRow, int startColumn, int endColumn)` Check if submatrix ranges indices are valid.
    `protected void` | `checkSubtractionCompatible(FieldMatrix<T> m)` Check if a matrix is subtraction compatible with the instance
    `abstract FieldMatrix<T>` | `copy()` Returns a (deep) copy of this.
    `void` | `copySubMatrix(int[] selectedRows, int[] selectedColumns, T[][] destination)` Copy a submatrix.
    `void` | `copySubMatrix(int startRow, int endRow, int startColumn, int endColumn, T[][] destination)` Copy a submatrix.
    `abstract FieldMatrix<T>` | `createMatrix(int rowDimension, int columnDimension)` Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
    `boolean` | `equals(Object object)` Returns true iff `object` is a `FieldMatrix` instance with the same dimensions as this and all corresponding matrix entries are equal.
    `protected static <T extends FieldElement<T>> Field<T>` | `extractField(T[] d)` Get the elements type from an array.
    `protected static <T extends FieldElement<T>> Field<T>` | `extractField(T[][] d)` Get the elements type from an array.
    `T[]` | `getColumn(int column)` Returns the entries in column number `col` as an array.
    `abstract int` | `getColumnDimension()` Returns the number of columns in the matrix.
    `FieldMatrix<T>` | `getColumnMatrix(int column)` Returns the entries in column number `column` as a column matrix.
    `FieldVector<T>` | `getColumnVector(int column)` Returns the entries in column number `column` as a vector.
    `T[][]` | `getData()` Returns matrix entries as a two-dimensional array.
    `abstract T` | `getEntry(int row, int column)` Returns the entry in the specified row and column.
    `Field<T>` | `getField()` Get the type of field elements of the matrix.
    `T[]` | `getRow(int row)` Returns the entries in row number `row` as an array.
    `abstract int` | `getRowDimension()` Returns the number of rows in the matrix.
    `FieldMatrix<T>` | `getRowMatrix(int row)` Returns the entries in row number `row` as a row matrix.
    `FieldVector<T>` | `getRowVector(int row)` Returns the entries in row number `row` as a vector.
    `FieldMatrix<T>` | `getSubMatrix(int[] selectedRows, int[] selectedColumns)` Gets a submatrix.
    `FieldMatrix<T>` | `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Gets a submatrix.
    `T` | `getTrace()` Returns the trace of the matrix (the sum of the elements on the main diagonal).
    `int` | `hashCode()` Computes a hashcode for the matrix.
    `boolean` | `isSquare()` Is this a square matrix?
    `FieldMatrix<T>` | `multiply(FieldMatrix<T> m)` Returns the result of postmultiplying this by m.
    `abstract void` | `multiplyEntry(int row, int column, T factor)` Change an entry in the specified row and column.
    `FieldVector<T>` | `operate(FieldVector<T> v)` Returns the result of multiplying this by the vector `v`.
    `T[]` | `operate(T[] v)` Returns the result of multiplying this by the vector `v`.
    `FieldMatrix<T>` | `preMultiply(FieldMatrix<T> m)` Returns the result premultiplying this by `m`.
    `FieldVector<T>` | `preMultiply(FieldVector<T> v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `T[]` | `preMultiply(T[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `FieldMatrix<T>` | `scalarAdd(T d)` Returns the result of adding d to each entry of this.
    `FieldMatrix<T>` | `scalarMultiply(T d)` Returns the result multiplying each entry of this by d.
    `void` | `setColumn(int column, T[] array)` Sets the entries in column number `column` as a column matrix.
    `void` | `setColumnMatrix(int column, FieldMatrix<T> matrix)` Sets the entries in column number `column` as a column matrix.
    `void` | `setColumnVector(int column, FieldVector<T> vector)` Sets the entries in column number `column` as a vector.
    `abstract void` | `setEntry(int row, int column, T value)` Set the entry in the specified row and column.
    `void` | `setRow(int row, T[] array)` Sets the entries in row number `row` as a row matrix.
    `void` | `setRowMatrix(int row, FieldMatrix<T> matrix)` Sets the entries in row number `row` as a row matrix.
    `void` | `setRowVector(int row, FieldVector<T> vector)` Sets the entries in row number `row` as a vector.
    `void` | `setSubMatrix(T[][] subMatrix, int row, int column)` Replace the submatrix starting at `row, column` using data in the input `subMatrix` array.
    `FieldMatrix<T>` | `subtract(FieldMatrix<T> m)` Compute this minus m.
    `String` | `toString()` Get a string representation for this matrix.
    `FieldMatrix<T>` | `transpose()` Returns the transpose of this matrix.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in column order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field

          private final Field<T extends FieldElement<T>> field

      Field to which the elements belong.

  - ### Constructor Detail

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix()

      Constructor for use with Serializable

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix(Field<T> field)

      Creates a matrix with no data
      Parameters:
        `field` - field to which the elements belong

    - #### AbstractFieldMatrix

          protected AbstractFieldMatrix(Field<T> field,
                             int rowDimension,
                             int columnDimension)
                                 throws IllegalArgumentException

      Create a new FieldMatrix with the supplied row and column dimensions.
      Parameters:
        `field` - field to which the elements belong
        `rowDimension` - the number of rows in the new matrix
        `columnDimension` - the number of columns in the new matrix
      Throws:
        `IllegalArgumentException` - if row or column dimension is not positive

  - ### Method Detail

    - #### extractField

          protected static <T extends FieldElement<T>> Field<T> extractField(T[][] d)
                                                                  throws IllegalArgumentException

      Get the elements type from an array.
      Type Parameters:
        `T` - the type of the field elements
      Parameters:
        `d` - data array
      Returns:
        field to which array elements belong
      Throws:
        `IllegalArgumentException` - if array is empty

    - #### extractField

          protected static <T extends FieldElement<T>> Field<T> extractField(T[] d)
                                                                  throws IllegalArgumentException

      Get the elements type from an array.
      Type Parameters:
        `T` - the type of the field elements
      Parameters:
        `d` - data array
      Returns:
        field to which array elements belong
      Throws:
        `IllegalArgumentException` - if array is empty

    - #### buildArray

          protected static <T extends FieldElement<T>> T[][] buildArray(Field<T> field,
                                                     int rows,
                                                     int columns)

      Build an array of elements.

      Complete arrays are filled with field.getZero()

      Type Parameters:
        `T` - the type of the field elements
      Parameters:
        `field` - field to which array elements belong
        `rows` - number of rows
        `columns` - number of columns (may be negative to build partial arrays in the same way `new Field[rows][]` works)
      Returns:
        a new array

    - #### buildArray

          protected static <T extends FieldElement<T>> T[] buildArray(Field<T> field,
                                                   int length)

      Build an array of elements.

      Arrays are filled with field.getZero()

      Type Parameters:
        `T` - the type of the field elements
      Parameters:
        `field` - field to which array elements belong
        `length` - of the array
      Returns:
        a new array

    - #### getField

          public Field<T> getField()

      Get the type of field elements of the matrix.
      Specified by:
        `getField` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        type of field elements of the matrix

    - #### createMatrix

          public abstract FieldMatrix<T> createMatrix(int rowDimension,
                                    int columnDimension)
                                                                       throws IllegalArgumentException

      Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
      Specified by:
        `createMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `rowDimension` - the number of rows in the new matrix
        `columnDimension` - the number of columns in the new matrix
      Returns:
        a new matrix of the same type as the instance
      Throws:
        `IllegalArgumentException` - if row or column dimension is not positive

    - #### copy

          public abstract FieldMatrix<T> copy()

      Returns a (deep) copy of this.
      Specified by:
        `copy` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        matrix copy

    - #### add

          public FieldMatrix<T> add(FieldMatrix<T> m)
                                                     throws IllegalArgumentException

      Compute the sum of this and m.
      Specified by:
        `add` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - matrix to be added
      Returns:
        this + m
      Throws:
        `IllegalArgumentException` - if m is not the same size as this

    - #### subtract

          public FieldMatrix<T> subtract(FieldMatrix<T> m)
                                                          throws IllegalArgumentException

      Compute this minus m.
      Specified by:
        `subtract` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - matrix to be subtracted
      Returns:
        this + m
      Throws:
        `IllegalArgumentException` - if m is not the same size as this

    - #### scalarAdd

          public FieldMatrix<T> scalarAdd(T d)

      Returns the result of adding d to each entry of this.
      Specified by:
        `scalarAdd` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `d` - value to be added to each entry
      Returns:
        d + this

    - #### scalarMultiply

          public FieldMatrix<T> scalarMultiply(T d)

      Returns the result multiplying each entry of this by d.
      Specified by:
        `scalarMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `d` - value to multiply all entries by
      Returns:
        d * this

    - #### multiply

          public FieldMatrix<T> multiply(FieldMatrix<T> m)
                                                          throws IllegalArgumentException

      Returns the result of postmultiplying this by m.
      Specified by:
        `multiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - matrix to postmultiply by
      Returns:
        this * m
      Throws:
        `IllegalArgumentException` - if columnDimension(this) != rowDimension(m)

    - #### preMultiply

          public FieldMatrix<T> preMultiply(FieldMatrix<T> m)
                                                             throws IllegalArgumentException

      Returns the result premultiplying this by `m`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `m` - matrix to premultiply by
      Returns:
        m * this
      Throws:
        `IllegalArgumentException` - if rowDimension(this) != columnDimension(m)

    - #### getData

          public T[][] getData()

      Returns matrix entries as a two-dimensional array.
      Specified by:
        `getData` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        2-dimensional array of entries

    - #### getSubMatrix

          public FieldMatrix<T> getSubMatrix(int startRow,
                                    int endRow,
                                    int startColumn,
                                    int endColumn)
                                                              throws MatrixIndexException

      Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Specified by:
        `getSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        The subMatrix containing the data of the specified rows and columns
      Throws:
        `MatrixIndexException` - if the indices are not valid

    - #### getSubMatrix

          public FieldMatrix<T> getSubMatrix(int[] selectedRows,
                                    int[] selectedColumns)
                                                              throws MatrixIndexException

      Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Specified by:
        `getSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
      Returns:
        The subMatrix containing the data in the specified rows and columns
      Throws:
        `MatrixIndexException` - if row or column selections are not valid

    - #### copySubMatrix

          public void copySubMatrix(int startRow,
                           int endRow,
                           int startColumn,
                           int endColumn,
                           T[][] destination)
                             throws MatrixIndexException,
                                    IllegalArgumentException

      Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Specified by:
        `copySubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
        `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `IllegalArgumentException` - if the destination array is too small

    - #### copySubMatrix

          public void copySubMatrix(int[] selectedRows,
                           int[] selectedColumns,
                           T[][] destination)
                             throws MatrixIndexException,
                                    IllegalArgumentException

      Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Specified by:
        `copySubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
        `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `IllegalArgumentException` - if the destination array is too small

    - #### setSubMatrix

          public void setSubMatrix(T[][] subMatrix,
                          int row,
                          int column)
                            throws MatrixIndexException

      Replace the submatrix starting at `row, column` using data in the input `subMatrix` array. Indexes are 0-based.

      Example:
      Starting with

           1  2  3  4
           5  6  7  8
           9  0  1  2

      and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

           1  2  3  4
           5  3  4  8
           9  5  6  2

      Specified by:
        `setSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `subMatrix` - array containing the submatrix replacement data
        `row` - row coordinate of the top, left element to be replaced
        `column` - column coordinate of the top, left element to be replaced
      Throws:
        `MatrixIndexException` - if subMatrix does not fit into this matrix from element in (row, column)

    - #### getRowMatrix

          public FieldMatrix<T> getRowMatrix(int row)
                                                              throws MatrixIndexException

      Returns the entries in row number `row` as a row matrix. Row indices start at 0.
      Specified by:
        `getRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be fetched
      Returns:
        row matrix
      Throws:
        `MatrixIndexException` - if the specified row index is invalid

    - #### setRowMatrix

          public void setRowMatrix(int row,
                          FieldMatrix<T> matrix)
                            throws MatrixIndexException,
                                   InvalidMatrixException

      Sets the entries in row number `row` as a row matrix. Row indices start at 0.
      Specified by:
        `setRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be set
        `matrix` - row matrix (must have one row and the same number of columns as the instance)
      Throws:
        `MatrixIndexException` - if the specified row index is invalid
        `InvalidMatrixException` - if the matrix dimensions do not match one instance row

    - #### getColumnMatrix

          public FieldMatrix<T> getColumnMatrix(int column)
                                                                 throws MatrixIndexException

      Returns the entries in column number `column` as a column matrix. Column indices start at 0.
      Specified by:
        `getColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be fetched
      Returns:
        column matrix
      Throws:
        `MatrixIndexException` - if the specified column index is invalid

    - #### setColumnMatrix

          public void setColumnMatrix(int column,
                             FieldMatrix<T> matrix)
                               throws MatrixIndexException,
                                      InvalidMatrixException

      Sets the entries in column number `column` as a column matrix. Column indices start at 0.
      Specified by:
        `setColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be set
        `matrix` - column matrix (must have one column and the same number of rows as the instance)
      Throws:
        `MatrixIndexException` - if the specified column index is invalid
        `InvalidMatrixException` - if the matrix dimensions do not match one instance column

    - #### getRowVector

          public FieldVector<T> getRowVector(int row)
                                                              throws MatrixIndexException

      Returns the entries in row number `row` as a vector. Row indices start at 0.
      Specified by:
        `getRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be fetched
      Returns:
        row vector
      Throws:
        `MatrixIndexException` - if the specified row index is invalid

    - #### setRowVector

          public void setRowVector(int row,
                          FieldVector<T> vector)
                            throws MatrixIndexException,
                                   InvalidMatrixException

      Sets the entries in row number `row` as a vector. Row indices start at 0.
      Specified by:
        `setRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be set
        `vector` - row vector (must have the same number of columns as the instance)
      Throws:
        `MatrixIndexException` - if the specified row index is invalid
        `InvalidMatrixException` - if the vector dimension does not match one instance row

    - #### getColumnVector

          public FieldVector<T> getColumnVector(int column)
                                                                 throws MatrixIndexException

      Returns the entries in column number `column` as a vector. Column indices start at 0.
      Specified by:
        `getColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be fetched
      Returns:
        column vector
      Throws:
        `MatrixIndexException` - if the specified column index is invalid

    - #### setColumnVector

          public void setColumnVector(int column,
                             FieldVector<T> vector)
                               throws MatrixIndexException,
                                      InvalidMatrixException

      Sets the entries in column number `column` as a vector. Column indices start at 0.
      Specified by:
        `setColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be set
        `vector` - column vector (must have the same number of rows as the instance)
      Throws:
        `MatrixIndexException` - if the specified column index is invalid
        `InvalidMatrixException` - if the vector dimension does not match one instance column

    - #### getRow

          public T[] getRow(int row)
                                             throws MatrixIndexException

      Returns the entries in row number `row` as an array.

      Row indices start at 0. A `MatrixIndexException` is thrown unless `0 <= row < rowDimension.`

      Specified by:
        `getRow` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be fetched
      Returns:
        array of entries in the row
      Throws:
        `MatrixIndexException` - if the specified row index is not valid

    - #### setRow

          public void setRow(int row,
                    T[] array)
                      throws MatrixIndexException,
                             InvalidMatrixException

      Sets the entries in row number `row` as a row matrix. Row indices start at 0.
      Specified by:
        `setRow` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - the row to be set
        `array` - row matrix (must have the same number of columns as the instance)
      Throws:
        `MatrixIndexException` - if the specified row index is invalid
        `InvalidMatrixException` - if the array size does not match one instance row

    - #### getColumn

          public T[] getColumn(int column)
                                                throws MatrixIndexException

      Returns the entries in column number `col` as an array.

      Column indices start at 0. A `MatrixIndexException` is thrown unless `0 <= column < columnDimension.`

      Specified by:
        `getColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be fetched
      Returns:
        array of entries in the column
      Throws:
        `MatrixIndexException` - if the specified column index is not valid

    - #### setColumn

          public void setColumn(int column,
                       T[] array)
                         throws MatrixIndexException,
                                InvalidMatrixException

      Sets the entries in column number `column` as a column matrix. Column indices start at 0.
      Specified by:
        `setColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `column` - the column to be set
        `array` - column array (must have the same number of rows as the instance)
      Throws:
        `MatrixIndexException` - if the specified column index is invalid
        `InvalidMatrixException` - if the array size does not match one instance column

    - #### getEntry

          public abstract T getEntry(int row,
                   int column)
                                                      throws MatrixIndexException

      Returns the entry in the specified row and column.

      Row and column indices start at 0 and must satisfy

      - `0 <= row < rowDimension`
      - `0 <= column < columnDimension`
      otherwise a `MatrixIndexException` is thrown.
      Specified by:
        `getEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be fetched
        `column` - column location of entry to be fetched
      Returns:
        matrix entry in row,column
      Throws:
        `MatrixIndexException` - if the row or column index is not valid

    - #### setEntry

          public abstract void setEntry(int row,
                      int column,
                      T value)
                                 throws MatrixIndexException

      Set the entry in the specified row and column.

      Row and column indices start at 0 and must satisfy

      - `0 <= row < rowDimension`
      - `0 <= column < columnDimension`
      otherwise a `MatrixIndexException` is thrown.
      Specified by:
        `setEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be set
        `column` - column location of entry to be set
        `value` - matrix entry to be set in row,column
      Throws:
        `MatrixIndexException` - if the row or column index is not valid

    - #### addToEntry

          public abstract void addToEntry(int row,
                        int column,
                        T increment)
                                   throws MatrixIndexException

      Change an entry in the specified row and column.

      Row and column indices start at 0 and must satisfy

      - `0 <= row < rowDimension`
      - `0 <= column < columnDimension`
      otherwise a `MatrixIndexException` is thrown.
      Specified by:
        `addToEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be set
        `column` - column location of entry to be set
        `increment` - value to add to the current matrix entry in row,column
      Throws:
        `MatrixIndexException` - if the row or column index is not valid

    - #### multiplyEntry

          public abstract void multiplyEntry(int row,
                           int column,
                           T factor)
                                      throws MatrixIndexException

      Change an entry in the specified row and column.

      Row and column indices start at 0 and must satisfy

      - `0 <= row < rowDimension`
      - `0 <= column < columnDimension`
      otherwise a `MatrixIndexException` is thrown.
      Specified by:
        `multiplyEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `row` - row location of entry to be set
        `column` - column location of entry to be set
        `factor` - multiplication factor for the current matrix entry in row,column
      Throws:
        `MatrixIndexException` - if the row or column index is not valid

    - #### transpose

          public FieldMatrix<T> transpose()

      Returns the transpose of this matrix.
      Specified by:
        `transpose` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        transpose matrix

    - #### isSquare

          public boolean isSquare()

      Is this a square matrix?
      Specified by:
        `isSquare` in interface `AnyMatrix`
      Returns:
        true if the matrix is square (rowDimension = columnDimension)

    - #### getRowDimension

          public abstract int getRowDimension()

      Returns the number of rows in the matrix.
      Specified by:
        `getRowDimension` in interface `AnyMatrix`
      Returns:
        rowDimension

    - #### getColumnDimension

          public abstract int getColumnDimension()

      Returns the number of columns in the matrix.
      Specified by:
        `getColumnDimension` in interface `AnyMatrix`
      Returns:
        columnDimension

    - #### getTrace

          public T getTrace()
                                             throws NonSquareMatrixException

      Returns the trace of the matrix (the sum of the elements on the main diagonal).
      Specified by:
        `getTrace` in interface `FieldMatrix<T extends FieldElement<T>>`
      Returns:
        trace
      Throws:
        `NonSquareMatrixException` - if the matrix is not square

    - #### operate

          public T[] operate(T[] v)
                                              throws IllegalArgumentException

      Returns the result of multiplying this by the vector `v`.
      Specified by:
        `operate` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the vector to operate on
      Returns:
        this*v
      Throws:
        `IllegalArgumentException` - if columnDimension != v.size()

    - #### operate

          public FieldVector<T> operate(FieldVector<T> v)
                                                         throws IllegalArgumentException

      Returns the result of multiplying this by the vector `v`.
      Specified by:
        `operate` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the vector to operate on
      Returns:
        this*v
      Throws:
        `IllegalArgumentException` - if columnDimension != v.size()

    - #### preMultiply

          public T[] preMultiply(T[] v)
                                                  throws IllegalArgumentException

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        v*this
      Throws:
        `IllegalArgumentException` - if rowDimension != v.size()

    - #### preMultiply

          public FieldVector<T> preMultiply(FieldVector<T> v)
                                                             throws IllegalArgumentException

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Specified by:
        `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        v*this
      Throws:
        `IllegalArgumentException` - if rowDimension != v.size()

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)
                                                   throws MatrixVisitorException

      Visit (and possibly change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)
                                                   throws MatrixVisitorException

      Visit (but don't change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)
                                                   throws MatrixIndexException,
                                                          MatrixVisitorException

      Visit (and possibly change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)
                                                   throws MatrixIndexException,
                                                          MatrixVisitorException

      Visit (but don't change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Specified by:
        `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)
                                                      throws MatrixVisitorException

      Visit (and possibly change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)
                                                      throws MatrixVisitorException

      Visit (but don't change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                                                      throws MatrixIndexException,
                                                             MatrixVisitorException

      Visit (and possibly change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          public T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                                                      throws MatrixIndexException,
                                                             MatrixVisitorException

      Visit (but don't change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Specified by:
        `walkInColumnOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)
                                                         throws MatrixVisitorException

      Visit (and possibly change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)
                                                         throws MatrixVisitorException

      Visit (but don't change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)
                                                         throws MatrixIndexException,
                                                                MatrixVisitorException

      Visit (and possibly change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)
                                                         throws MatrixIndexException,
                                                                MatrixVisitorException

      Visit (but don't change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Specified by:
        `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `MatrixIndexException` - if the indices are not valid
        `MatrixVisitorException` - if the visitor cannot process an entry
      See Also:
        `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`

    - #### toString

          public String toString()

      Get a string representation for this matrix.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation for this matrix

    - #### equals

          public boolean equals(Object object)

      Returns true iff `object` is a `FieldMatrix` instance with the same dimensions as this and all corresponding matrix entries are equal.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `object` - the object to test equality against.
      Returns:
        true if object equals this

    - #### hashCode

          public int hashCode()

      Computes a hashcode for the matrix.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashcode for matrix

    - #### checkRowIndex

          protected void checkRowIndex(int row)

      Check if a row index is valid.
      Parameters:
        `row` - row index to check
      Throws:
        `MatrixIndexException` - if index is not valid

    - #### checkColumnIndex

          protected void checkColumnIndex(int column)
                                   throws MatrixIndexException

      Check if a column index is valid.
      Parameters:
        `column` - column index to check
      Throws:
        `MatrixIndexException` - if index is not valid

    - #### checkSubMatrixIndex

          protected void checkSubMatrixIndex(int startRow,
                                 int endRow,
                                 int startColumn,
                                 int endColumn)

      Check if submatrix ranges indices are valid. Rows and columns are indicated counting from 0 to n-1.
      Parameters:
        `startRow` - Initial row index
        `endRow` - Final row index
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Throws:
        `MatrixIndexException` - if the indices are not valid

    - #### checkSubMatrixIndex

          protected void checkSubMatrixIndex(int[] selectedRows,
                                 int[] selectedColumns)

      Check if submatrix ranges indices are valid. Rows and columns are indicated counting from 0 to n-1.
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
      Throws:
        `MatrixIndexException` - if row or column selections are not valid

    - #### checkAdditionCompatible

          protected void checkAdditionCompatible(FieldMatrix<T> m)

      Check if a matrix is addition compatible with the instance
      Parameters:
        `m` - matrix to check
      Throws:
        `IllegalArgumentException` - if matrix is not addition compatible with instance

    - #### checkSubtractionCompatible

          protected void checkSubtractionCompatible(FieldMatrix<T> m)

      Check if a matrix is subtraction compatible with the instance
      Parameters:
        `m` - matrix to check
      Throws:
        `IllegalArgumentException` - if matrix is not subtraction compatible with instance

    - #### checkMultiplicationCompatible

          protected void checkMultiplicationCompatible(FieldMatrix<T> m)

      Check if a matrix is multiplication compatible with the instance
      Parameters:
        `m` - matrix to check
      Throws:
        `IllegalArgumentException` - if matrix is not multiplication compatible with instance

Copyright (c) 2003-2013 Apache Software Foundation